#include <linux/module.h>
#include <linux/interrupt.h>

static void tasklet_function( unsigned long data )
{
	printk("Tasklet called...\n");
	return;
}

DECLARE_TASKLET( tl_descr, tasklet_function, 0L );

static int __init driver_init(void)
{
	printk("driver_init called\n");
	tasklet_schedule( &tl_descr ); // Tasklet sobald als mglich ausfhren
	return 0;
}

static void __exit driver_exit(void)
{
	printk("driver_exit called\n");
	tasklet_kill( &tl_descr );
}

module_init( driver_init );
module_exit( driver_exit );
MODULE_LICENSE("GPL");
