#include <linux/module.h>

static struct timer_list mytimer;

static void inc_count(unsigned long arg)
{
	static unsigned int mintime=0xffffffff, maxtime, curtime, lasttime=0;

	curtime = jiffies -lasttime;
	if( lasttime ) {
		if( curtime > maxtime )
			maxtime = curtime;
		if( curtime < mintime )
			mintime = curtime;
		printk("inc_count called (%ld)... %d - %d - %d\n",
			mytimer.expires, curtime, mintime, maxtime );
	}
	lasttime = jiffies;
	mytimer.expires = jiffies + (2*HZ); // 2 second
	add_timer( &mytimer );
}

static int __init ktimer_init(void)
{
	init_timer( &mytimer );
	mytimer.function = inc_count;
	mytimer.data = 0;
	mytimer.expires = jiffies + (2*HZ); // 2 second
	add_timer( &mytimer );
	return 0;
}

static void __exit ktimer_exit(void)
{
	if( del_timer_sync( &mytimer ) )
		printk("Aktiver Timer deaktiviert\n");
}

module_init( ktimer_init );
module_exit( ktimer_exit );
MODULE_LICENSE("GPL");
