#include <linux/module.h>
#include <linux/cpufreq.h>

static struct timer_list mytimer;

static void inc_count(unsigned long arg)
{
	static unsigned int mintime=0xffffffff, maxtime, lasttime=0;
	static unsigned long oldtsc=0;
	unsigned int curtime, freq;
	unsigned long tscval=0, curtsc;
	
	curtime = jiffies -lasttime;
	rdtscl( tscval );
	if( oldtsc ) {
		curtsc = tscval - oldtsc;
		freq = cpufreq_get(0);
		printk("time in usec(%ld): %ld\n", curtsc, curtsc/freq );
	}
	oldtsc = tscval;
	if( lasttime ) {
		if( curtime > maxtime )
			maxtime = curtime;
		if( curtime < mintime )
			mintime = curtime;
		printk("inc_count called (%ld)... %d - %d - %d\n",
			mytimer.expires, curtime, mintime, maxtime );
	}
	lasttime = jiffies;
	mytimer.expires = jiffies + (2*HZ); // 2 second
	add_timer( &mytimer );
}

static int __init ktimer_init(void)
{
	init_timer( &mytimer );
	mytimer.function = inc_count;
	mytimer.data = 0;
	mytimer.expires = jiffies + (2*HZ); // 2 second
	add_timer( &mytimer );
	return 0;
}

static void __exit ktimer_exit(void)
{
	if( del_timer_sync( &mytimer ) )
		printk("Aktiver Timer deaktiviert\n");
}

module_init( ktimer_init );
module_exit( ktimer_exit );
MODULE_LICENSE("GPL");
