#include <linux/module.h>
#include <linux/init.h>
#include <linux/in.h>
#include <net/sock.h>

static int thread_id=0;
static DECLARE_COMPLETION( on_exit );
static wait_queue_head_t wq;

static int thread_code( void *data )
{
	unsigned long timeout;

	daemonize("mykthread");
	allow_signal( SIGTERM );
	init_waitqueue_head( &wq );
	printk("thread_code startet ...\n");
	while( !signal_pending(current) ) {
		timeout=HZ;
		timeout=wait_event_interruptible_timeout(
			wq, (timeout==0),timeout );
		printk("wakeup...\n");
		if( timeout==-ERESTARTSYS ) {
			printk("got signal...\n");
			break;
		}
	}
	printk("End\n");
	complete_and_exit( &on_exit, 0 );
}

static int __init kthread_init(void)
{
	thread_id=kernel_thread(thread_code,NULL,CLONE_KERNEL);
	if( thread_id==0 )
		return -EIO;
	return 0;
}

static void __exit kthread_exit(void)
{
	kill_pid(find_pid_ns(thread_id, &init_pid_ns), SIGTERM, 1);
	wait_for_completion( &on_exit );
}

module_init( kthread_init );
module_exit( kthread_exit );
MODULE_LICENSE("GPL");
