#include <linux/module.h>

static void work_queue_func( struct work_struct *work );
static struct workqueue_struct *wq;
//static DECLARE_WORK( work_obj, work_queue_func );
static DECLARE_DELAYED_WORK( work_obj, work_queue_func );

static void work_queue_func( struct work_struct *work )
{
	printk( "work_queue_func\n");
	return;
}


static int __init drv_init(void)
{
	wq = create_workqueue( "meine_wq" );
	if( queue_delayed_work( wq, &work_obj, 10*HZ ) ) {
		printk( "queue_work successful ...\n");
	} else {
		printk( "queue_work not successful ...\n");
	}
	return 0;
}

static void __exit drv_exit(void)
{
	printk("drv_exit called\n");
	if( wq ) {
		cancel_delayed_work( &work_obj );
		flush_workqueue( wq );
		destroy_workqueue( wq );
		printk("workqueue destroyed\n");
	}
}

module_init( drv_init );
module_exit( drv_exit );
MODULE_LICENSE("GPL");
