#include <linux/module.h>
#include <linux/fs.h>
#include <linux/sched.h>

DEFINE_MUTEX( m );

static int driver_open( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_open HZ=%d\n", HZ);
	while( mutex_trylock( &m ) == 0 ) {
		printk("Mutex belegt (%ld)...\n", jiffies);
		schedule_timeout_interruptible( 200*HZ/1000 );
		if( signal_pending(current) ) {
			mutex_unlock( &m );
			return -EIO;
		}
	}
	schedule_timeout_interruptible( 3*HZ );
	mutex_unlock( &m );
	return 0;
}

static struct file_operations fops = {
	.owner = THIS_MODULE,
	.open  = driver_open,
};

static int __init driver_init(void)
{
	printk("driver_init called\n");
	if( register_chrdev( 240, "buf", &fops )==0 ) {
		return 0;
	}
	printk("loading failed\n");
	return -EIO;
}

static void __exit driver_exit(void)
{
	unregister_chrdev( 240, "buf" );
	printk("driver_exit called\n");
}

module_init( driver_init );
module_exit( driver_exit );
MODULE_LICENSE("GPL");
