#include <linux/module.h>
#include <linux/fs.h>
#include <linux/device.h>
#include <asm/uaccess.h>

static char *hello = "hello world\n";
static int major=0;

static int driver_open( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_open\n");
	return 0;
}

static int driver_release( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_release\n");
	return 0;
}

static ssize_t driver_read(struct file *instanz,char __user *buf,size_t count,
	loff_t *offset )
{
	int not_copied=0;
	int to_copy = min( strlen(hello)+1, count );

	if( to_copy ) {
		not_copied = copy_to_user( buf, hello, to_copy );
	}
	return to_copy-not_copied;
}

static struct file_operations fops = {
	.owner = THIS_MODULE,
	.open  = driver_open,
	.release = driver_release,
	.read = driver_read,
};

static struct class *company_class;

static int __init udevmod_init(void)
{
	printk("udevmod_init called\n");
	if( (major=register_chrdev( 0, "openclose", &fops )) ) {
		company_class = class_create( THIS_MODULE, "company" );
		if( IS_ERR( company_class ) ) {
			printk("no udev support\n");
			unregister_chrdev( major, "udev" );
			return -EIO;
		}
		device_create( company_class, NULL, MKDEV(major,0),
			NULL, "lulu" );
		return 0;
	}
	printk("loading failed\n");
	return -EIO;
}

static void __exit usevmod_exit(void)
{
	unregister_chrdev( major, "udev" );
	if( !IS_ERR( company_class ) ) {
		device_destroy(company_class,MKDEV(major,0));
		class_destroy( company_class );
	}
	printk("cleanup_module called\n");
}

module_init( udevmod_init );
module_exit( usevmod_exit );
MODULE_LICENSE("GPL");

