#include <linux/module.h>
#include <linux/fs.h>

static struct file_operations fops;

static int __init driver_init(void)
{
	printk("driver_init called\n");
	if( register_chrdev( 240, "treiber", &fops )==0 ) {
		return 0;
	}
	printk("loading failed\n");
	return -EIO;
}

static void __exit driver_exit(void)
{
	unregister_chrdev( 240, "treiber" );
	printk("driver_exit called\n");
}

module_init( driver_init );
module_exit( driver_exit );
MODULE_LICENSE("GPL");
