#include <linux/module.h>
#include <linux/fs.h>

static atomic_t access_count = ATOMIC_INIT(-1);

static int driver_open( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_open\n");
	if( atomic_inc_and_test( &access_count )!=0) { // true, falls ==0
		printk("allowed...\n");
		return 0;
	}
	printk("forbidden...\n");
	atomic_dec( &access_count );
	return -EBUSY;
}

static int driver_release( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_release\n");
	atomic_dec( &access_count );
	return 0;
}

static struct file_operations fops = {
	.owner = THIS_MODULE,
	.open  = driver_open,
	.release = driver_release,
};

static int __init driver_init(void)
{
	printk("driver_init called\n");
	if( register_chrdev( 240, "openclose", &fops )==0 ) {
		return 0;
	}
	printk("loading failed\n");
	return -EIO;
}

static void __exit driver_exit(void)
{
	unregister_chrdev( 240, "openclose" );
	printk("driver_exit called\n");
}

module_init( driver_init );
module_exit( driver_exit );
MODULE_LICENSE("GPL");

