#include <linux/module.h>
#include <linux/fs.h>
#include <asm/uaccess.h>

static char *hello = "hello world\n";

static int driver_open( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_open\n");
	return 0;
}

static int driver_release( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_release\n");
	return 0;
}

static ssize_t driver_read(struct file *instanz,char __user *buf,size_t count,
	loff_t *offset )
{
	char nll='\0';
	int not_copied=0;
	int to_copy = min( strlen(hello)+1, count );

	if( to_copy==0 )
		return 0;
	if( iminor(instanz->f_dentry->d_inode)==0 ) {
		printk("Minornummer 0\n");
		not_copied = copy_to_user( buf, &nll, 1 );
	} else {
		printk("Minornummer %d\n",iminor(instanz->f_dentry->d_inode));
		not_copied = copy_to_user( buf, hello, to_copy );
	}
	return count-not_copied;
}

static struct file_operations fops = {
	.owner = THIS_MODULE,
	.open  = driver_open,
	.release = driver_release,
	.read = driver_read,
};

static int __init driver_init(void)
{
	printk("driver_init called\n");
	if( register_chrdev( 240, "openclose", &fops )==0 ) {
		return 0;
	}
	printk("loading failed\n");
	return -EIO;
}

static void __exit driver_exit(void)
{
	unregister_chrdev( 240, "openclose" );
	printk("driver_exit called\n");
}

module_init( driver_init );
module_exit( driver_exit );
MODULE_LICENSE("GPL");
