#include <linux/module.h>
#include <linux/fs.h>
#include <asm/uaccess.h>

static int driver_open( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_open\n");
	return 0;
}

static int driver_release( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_release\n");
	return 0;
}

static ssize_t driver_write(struct file *instanz,const char __user *buf,
	size_t count, loff_t *offset )
{
	return count;
}

static struct file_operations fops = {
	.owner = THIS_MODULE,
	.open  = driver_open,
	.release = driver_release,
	.write = driver_write,
};

static int __init driver_init(void)
{
	printk("driver_init called\n");
	if( register_chrdev( 240, "mynull", &fops )==0 ) {
		return 0;
	}
	printk("loading failed\n");
	return -EIO;
}

static void __exit driver_exit(void)
{
	unregister_chrdev( 240, "mynull" );
	printk("driver_exit called\n");
}

module_init( driver_init );
module_exit( driver_exit );
MODULE_LICENSE("GPL");
