#include <linux/module.h>
#include <linux/fs.h>
#include <linux/device.h>
#include <asm/uaccess.h>

static char *hello = "hello world\n";
static int major=0;

static int driver_open( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_open\n");
	return 0;
}

static int driver_release( struct inode *geraetedatei, struct file *instanz )
{
	printk("driver_release\n");
	return 0;
}

static ssize_t driver_read(struct file *instanz,char __user *buf,size_t count,
	loff_t *offset )
{
	int not_copied=0, to_copy;

	...
	return to_copy-not_copied;
}

static struct file_operations fops = {
	.owner = THIS_MODULE,
	.open  = driver_open,
	.release = driver_release,
	.read = driver_read,
};

static struct class *lulu_class;

static int __init template_init(void)
{
	printk("template_init called\n");
	if( (major=register_chrdev( 0, "lulu", &fops )) ) {
		lulu_class = class_create( THIS_MODULE, "lulu-class" );
		if( IS_ERR( lulu_class ) ) {
			printk("no udev support\n");
			unregister_chrdev( major, "lulu" );
			return -EIO;
		}
		device_create( lulu_class, NULL, MKDEV(major,0),
			NULL, "lulu" );
		return 0;
	}
	printk("loading failed\n");
	return -EIO;
}

static void __exit template_exit(void)
{
	unregister_chrdev( major, "lulu" );
	if( !IS_ERR( lulu_class ) ) {
		device_destroy(lulu_class,MKDEV(major,0));
		class_destroy( lulu_class );
	}
	printk("cleanup_module called\n");
}

module_init( template_init );
module_exit( template_exit );
MODULE_LICENSE("GPL");

